-- reporter: make sure the whole guild knows of your success and shame
-- Original idea by Harpo
-- modified heavily & redesigned by Estrian
-- v1.5 Fixed a bug reporting yourself as killer and uses proper /me tags
--  

declare('reporter', {})


reporter.NoArgs={}
reporter.toggle={}
reporter.Init={}
reporter.someDeath={}
reporter.GroupEvents={}
reporter.GroupModeToggle={}
reporter.ArgToggle={}

reporter.pluginState = true
reporter.disablechatgroup = false

function reporter.NoArgs()
	print('\127ffffffCommands are /reporter [toggle/on/off/group]\127o')
end
	

function reporter.ArgToggle()
	if reporter.pluginState == true then
		reporter.pluginState = false
		print('reporter toggled, OFF')
	else 
		reporter.pluginState = true
		print('reporter toggled, ON')
	end
end

function reporter.toggle(data,args)
	if not args then
		reporter.NoArgs()
	elseif args[1]=='toggle' then
		reporter.ArgToggle()
	elseif args[1]=='on' then 
		reporter.pluginState = true
		print('reporter ON')
	elseif args[1]=='off' then 
		reporter.pluginState = false
		print('reporter OFF')
	elseif args[1]=='group' then
		reporter.GroupModeToggle()
	else
	print('\127ffffffNot a valid argument\127o')
	end
end

function reporter.Init:OnEvent(event)
	reporter.pluginState = true
	reporter.disablechatgroup = false
end

function reporter.GroupModeToggle()
	if (reporter.disablechatgroup == false) then
		reporter.disablechatgroup = true
		print('\127ffffffGroup Mode active: No kills will be reported while in a group\127o')
	else
		reporter.disablechatgroup = false
		print('\127ffffffGroup Mode inactive: Kills will be reported even while in group\127o')
	end
end

function reporter.GroupEvents:OnEvent(eventname, args)
	if eventname=='GROUP_CREATED' or eventname =='GROUP_SELF_JOINED' then
		if reporter.disablechatgroup == true then
			reporter.pluginState = false
			print('\127ffffffreporter Autotoggled to OFF (group joined)\127o')
		end
	elseif eventname=='GROUP_SELF_LEFT' then
		if reporter.disablechatgroup == true then
			reporter.pluginState = true
			print('\127ffffffreporter Auto-toggled to ON (group left)\127o')
		end
	end
end

function reporter.someDeath:OnEvent(event, deadguyID, killerID)
	if reporter.pluginState == true then
		if (not GetPlayerName(deadguyID):match("^%*")) then
			if (not GetPlayerName(killerID):match("^%*")) then
				local selfID = GetCharacterID()
				if (deadguyID == killerID) then
					SendChat("/me managed to suicide with style" , "GUILD")
					print('triggered event1')
				elseif (deadguyID == selfID) and (killerID ~= selfID) then
					local killer = GetPlayerName(killerID)
					SendChat("/me was destroyed by ".. killer, "GUILD")
					print('triggered event2 and selfid ='.. selfID)
				else
					local deadguy = GetPlayerName(deadguyID) or "none"
					local killer = GetPlayerName(killerID) or "none"
					SendChat("/me destroyed " .. deadguy, "GUILD")
					print('triggered event3 and selfID='.. selfID)
				end
			end
		end
	end
end
-- Something is wrong here, that won't pass to the killer killed player when killer!=deadguy
-- AP ID = 317309
-- FC ID = 265808
-- Trigger /lua ProcessEvent("PLAYER_DIED", 317309, 265808)

RegisterEvent(reporter.someDeath, "PLAYER_DIED")
RegisterEvent(reporter.Init, "PLAYER_ENTERED_GAME")
RegisterEvent(reporter.GroupEvents, "GROUP_CREATED")
RegisterEvent(reporter.GroupEvents, "GROUP_SELF_LEFT")
RegisterEvent(reporter.GroupEvents, "GROUP_SELF_JOINED")

RegisterUserCommand('reporter', reporter.toggle)

-- for the anti-spam omit just store the messages in a table with table.insert(), then create a Timer() object and use :SetTimeout() to extract them.